=== debian/changelog ===
rspamd (0.8.3) UNRELEASED; urgency=low

  * New release.
  * systemd socket-activated service.
  * Bump Standards-Version, no changes required.

 -- Mikhail Gusarov <dottedmag@debian.org>  Sun, 08 Mar 2015 22:38:55 +0100

rspamd (0.6.9) unstable; urgency=low

  * Initial release (Closes: #683746)

 -- Mikhail Gusarov <dottedmag@debian.org>  Sun, 23 Mar 2014 19:04:13 +0100
